/**
 * @function execDply
 */

"use strict";

const argx = require('argx'),
    async = require('async'),
    apemandocker = require('apemandocker'),
    getDplys = require('./get_dplys');

/** @lends execDply */
function execDply(apemanfile, names, script, options, callback) {
    let args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};


    let docker = apemandocker.create({}),
        dplys = getDplys(apemanfile, names);

    async.eachSeries([].concat(dplys), (dply, callback) => {
        execDply.one(docker, script, dply, {}, callback);
    }, callback);
}

execDply.one = function (docker, script, dply, options, callback) {
    docker.execInContainer(dply.container, script.split(/\s+/g), options, callback);
};

module.exports = execDply;
