/**
 * @function logDply
 */

"use strict";

const argx = require('argx'),
    async = require('async'),
    apemandocker = require('apemandocker'),
    selectDply = require('./select_dply'),
    filterDply = require('./filter_dply'),
    getDplys = require('./get_dplys');

/** @lends logDply */
function logDply(apemanfile, names, options, callback) {
    let args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};

    let docker = apemandocker.create({}),
        dplys = getDplys(apemanfile, names);

    async.waterfall([
        (callback) => {
            if (names.length == 1) {
                callback(null, names[0]);
            } else {
                selectDply(dplys, callback);
            }
        },
        (name, callback) => {
            filterDply(dplys, name, callback);
        },
        (dply, callback) => {
            docker.logContainer(dply.container, {
                follow: options.follow
            }, callback);
        }
    ], callback);
}


module.exports = logDply;
