/**
 * @function ttyDply
 */

"use strict";

const argx = require('argx'),
    async = require('async'),
    apemandocker = require('apemandocker'),
    selectDply = require('./select_dply'),
    filterDply = require('./filter_dply'),
    getDplys = require('./get_dplys');

/** @lends ttyDply */
function ttyDply(apemanfile, names, options, callback) {
    let args = argx(arguments);
    callback = args.pop('function') || argx.noop;
    options = args.pop('object') || {};

    let docker = apemandocker.create({}),
        dplys = getDplys(apemanfile, names);

    async.waterfall([
        (callback) => {
            if (names.length == 1) {
                callback(null, names[0]);
            } else {
                selectDply(dplys, callback);
            }
        },
        (name, callback) => {
            filterDply(dplys, name, callback);
        },
        (dply, callback) => {
            let terminal = docker.terminal(dply.container);
            terminal.on('exit', ()=> {
                callback(null);
            });
        }
    ], callback);
}


module.exports = ttyDply;
