/**
 * Logger for list.
 * @constructor ListLogger
 */

"use strict";

const colorprint = require('colorprint'),
    path = require('path'),
    arrayfilter = require('arrayfilter'),
    extend = require('extend'),
    colors = colorprint.colors,
    textconv = require('textconv');

const NAME_MIN_LENGTH = 24;
const DESC_MAX_LEN = 64;

/** @lends ListLogger */
module.exports = colorprint.define(
    /** @lends ListLogger.prototype */
    {
        /**
         * Log dply list.
         * @param {object} dply - Infra to show.
         */
        logList: function (dply) {
            let s = this;
            s.debug('');
            s.debug('  Available dply:');
            s.debug('');
            [].concat(dply || {})
                .forEach((dply) => {
                    let conf = extend({}, dply);
                    delete conf.name;
                    let nameLabel = textconv.pad(dply.name, NAME_MIN_LENGTH),
                        descLabel = textconv.chop(textconv.inline(JSON.stringify(conf), {trim: true}), DESC_MAX_LEN, {
                            ellipsis: true
                        });
                    s.debug(`     ${colors.black.bold(nameLabel)}  ${colors.blackBright(descLabel)}`);
                });
            s.debug('');
        }
    }
);
