/**
 * Logger for remove.
 * @constructor RemoveLogger
 */

"use strict";

const colorprint = require('colorprint'),
    path = require('path'),
    arrayfilter = require('arrayfilter'),
    colors = colorprint.colors,
    textconv = require('textconv');


/** @lends RemoveLogger */
module.exports = colorprint.define(
    /** @lends RemoveLogger.prototype */
    {
        logRemoveStarted: function (name) {
            let s = this;
            s.info(`Removing ${name}...`);
            s.debug('');
        },
        logRemoveDone: function (name) {
            let s = this;
            s.info(`...removing ${name} done!`);
            s.debug('');
        },
        logNetworkRemoved: function (name) {
            let s = this;
            s.info(`Network removed: ${name}`);
        }
    }
);
