/**
 * Test case for apemanDply.
 * Runs with mocha.
 */
"use strict";

const apemanDply = require('../lib/apeman_dply.js'),
    apemanInfr = require('apeman-infr'),
    injectmock = require('injectmock'),
    assert = require('assert');

describe('apeman-dply', () => {

    let Apemanfile = require.resolve('../doc/mocks/mock-project/Apemanfile');

    before((done) => {
        done();
    });

    after((done) => {
        injectmock.restoreAll();
        done();
    });

    it('Build a infra', (done) => {
        apemanInfr({
            configuration: Apemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('List deploy', (done) => {
        apemanDply({
            configuration: Apemanfile,
            list: true
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Do deploy', (done) => {
        apemanDply({
            configuration: Apemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Re deploy', (done) => {
        apemanDply({
            rerun: true,
            force:true,
            configuration: Apemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Exec command ', (done) => {
        apemanDply({
            exec: "ls -l",
            configuration: Apemanfile
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Open tty', (done) => {
        apemanDply("hoge", {
            tty: true,
            configuration: Apemanfile
        }, (err) => {
            done();
        });
    });

    it('Remove deploy', (done) => {
        apemanDply({
            configuration: Apemanfile,
            delete: true,
            force: true
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Remove a infra', (done) => {
        apemanInfr({
            delete: true,
            configuration: Apemanfile,
            force: true
        }, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Try invalid options', (done) => {
        apemanDply({
            rerun: true,
            delete: true,
            tty: true,
            force: true
        }, (err) => {
            assert.ok(!!err);
            done();
        });
    });
});

